﻿init python:

    def map_generator(x, y):
        map = []
        for j in range(y):
            row = []
            for i in range(x):
                o = renpy.random.choice([0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9])
                r = renpy.random.choice([-90, 0, 90, 180])
                z = renpy.random.randint(4, 10)*.1
                if o in [8,9]:
                    z = 1
                if o:
                    row.append([o, r, z])
                else:
                    row.append(0)
            map.append(row)
        return map



    class tank:
        def __init__(self, model):
            self.model = model
            self.direction = 0
            self.x = 0
            self.y = 0
        def move(self, direction):
            if direction == "up":
                self.y -= 1
            elif direction == "left":
                self.x -= 1
            elif direction == "down":
                self.y += 1
            elif direction == "right":
                self.x += 1
        def direction_change(self, direction):
            if direction == "up":
                self.direction = 0
            elif direction == "left":
                self.direction = -90
            elif direction == "down":
                self.direction = 180
            elif direction == "right":
                self.direction = 90

    class world:
        def __init__(self, map):
            self.map = map_generator(15, 8)
            self.player = tank("T-54")
            self.map[6][7] = 0
            self.player.y = 6
            self.player.x = 7

            self.bullets = []


        def collision_check(self, direction):
            x, y = self.player.x, self.player.y
            if direction == "up":
                y -= 1
                if y < 0:
                    return True
                else:
                    if self.map[y][x] == 0:
                        return False
                    else:
                        return True
            elif direction == "left":
                x -= 1
                if x < 0:
                    return True
                else:
                    if self.map[y][x] == 0:
                        return False
                    else:
                        return True
            elif direction == "down":
                y += 1
                if y > len(self.map)-1:
                    return True
                else:
                    if self.map[y][x] == 0:
                        return False
                    else:
                        return True
            elif direction == "right":
                x += 1
                if x > len(self.map[0])-1:
                    return True
                else:
                    if self.map[y][x] == 0:
                        return False
                    else:
                        return True

        def move(self, direction):
            self.player.direction_change(direction)
            col = self.collision_check(direction)
            if not col:
                self.player.move(direction)
        def shoot(self):
            if not len(self.bullets):
                direction = self.player.direction
                xv = 0
                yv = 0
                if direction == 0:
                    yv = -1
                elif direction == -90:
                    xv = -1
                elif direction == 180:
                    yv = 1
                elif direction == 90:
                    xv = 1
                x = self.player.x + xv
                y = self.player.y + yv

                self.bullets.append([x, y, xv, yv, True, direction])
        def bullet_update(self):
            for i in self.bullets:
                i[4] = False
                if i[1] < 0 or i[1] > len(self.map)-1:
                    self.bullets.remove(i)
                elif i[0] < 0 or i[0] > len(self.map[0])-1:
                    self.bullets.remove(i)
                elif self.map[i[1]][i[0]]:
                    self.map[i[1]][i[0]] = 0
                    self.bullets.remove(i)
                else:
                    i[0] += i[2]
                    i[1] += i[3]
        def reset(self):
            self.map = map_generator(15, 8)
            self.map[6][7] = 0
            self.player.y = 6
            self.player.x = 7
            self.player.direction = 0

screen tank_map(g):
    add "bg"
    fixed:
        at zoom(2)
        fit_first True
        align .5,.5
        vbox:
            for j in g.map:
                hbox:
                    for i in j:
                        frame:
                            xysize 64,64 padding 0,0 background None
                            if i:
                                add "rock_{}".format(i[0]) at rotate_zoom(i[1], i[2]) align .5,.5
        frame:
            xysize 64,64 background None
            at tank_position(g.player.x*64, g.player.y*64)
            add "{}".format(g.player.model.lower()) align .5,.5 at tank_direction(g.player.direction)
            key "w" action Function(g.move, "up")
            key "a" action Function(g.move, "left")
            key "s" action Function(g.move, "down")
            key "d" action Function(g.move, "right")
            key "K_SPACE" action Function(g.shoot)

        for i in g.bullets:
            frame:
                xysize 64,64 background None
                add "bullets" align .5,.5
                if i[4]:
                    at tank_bullet_position(i[0]*64, i[1]*64, i[5], 0)
                else:
                    at tank_bullet_position(i[0]*64, i[1]*64, i[5])
        timer .1 repeat True action Function(g.bullet_update)
    button:
        text _("Reset")
        action Function(g.reset)
transform rotate_zoom(r, z):
    rotate r zoom z
transform zoom(z):
    zoom z
transform tank_bullet_position(x, y, d, t = .1):
    rotate_pad False
    rotate d
    linear t offset (x,y)
transform tank_position(x, y):
    ease .4 offset (x,y)
transform tank_direction(d):
    rotate_pad False
    ease .2 rotate d

default tank_stage_1 = world(
    map = [
        [0, 0, 1],
        [0, 2, 0],
        [0, 0, 0],
    ]
)


label tank_fight_example:
    call screen tank_map(tank_stage_1)


